
#include <windows.h>  
#include "GetChPl.h" 


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 

BOOL RegisterWin95( CONST WNDCLASS* lpwc );

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

LPCSTR lpszText = "This is a sample text string";
char   szNewText[29];
int    anDX[28];
USHORT auGlyphs[28];    


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   switch( uMsg )
   {
      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST :
                        {
                           HDC         hDC;
                           HFONT       hFont, hOldFont;
                           RECT        rect;
                           GCP_RESULTS results;

                           // Create font to use.
                           //....................
                           hFont = CreateFont( 16, 0, 0, 0, FW_NORMAL,
                                               FALSE, FALSE, FALSE,
                                               ANSI_CHARSET, 
                                               OUT_DEFAULT_PRECIS,
                                               CLIP_DEFAULT_PRECIS,
                                               PROOF_QUALITY,
                                               DEFAULT_PITCH | FF_DONTCARE,
                                               "Times New Roman" );


                           SetRect( &rect, 10, 10, 110, 30 );

                           // Retrieve device context and
                           // select the font into it.
                           //............................
                           hDC = GetDC( hWnd );
                           hOldFont = SelectObject( hDC, hFont );

                           Rectangle( hDC, rect.left-3, rect.top-3, 
                                           rect.right+3, rect.bottom+3 );

                           // Set up the structure for calling
                           // the GetCharacterPlacement() function.
                           //......................................
                           results.lStructSize = sizeof( results );
                           results.lpOutString = &szNewText[0];
                           results.lpOrder     = NULL;
                           results.lpDx        = &anDX[0];
                           results.lpCaretPos  = NULL;
                           results.lpClass     = NULL;
                           results.lpGlyphs    = &auGlyphs[0];
                           results.nGlyphs     = 15;
                           results.nMaxFit     = 0;
                    
                           // Justify the text to fit within the 
                           // maximum extent defined by the rect.
                           //....................................
                           GetCharacterPlacement( hDC, lpszText, 15, 
                                                  rect.right-rect.left,
                                                  &results, 
                                                  GCP_JUSTIFY|GCP_MAXEXTENT );

                           // Output the justified text.
                           //...........................
                           ExtTextOut( hDC, rect.left, rect.top, 0,
                                       NULL, szNewText, 
                                       strlen( szNewText ), anDX );

                           // Output the normal text.
                           //........................
                           ExtTextOut( hDC, 10, 40, 0, NULL, 
                                       lpszText, strlen( lpszText ), NULL );
                          
                           SelectObject( hDC, hOldFont );
                           ReleaseDC( hWnd, hDC );
                           DeleteObject( hFont );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
